// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/post"
	"gochassis/ent/profile"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ChatRoomCreate is the builder for creating a ChatRoom entity.
type ChatRoomCreate struct {
	config
	mutation *ChatRoomMutation
	hooks    []Hook
}

// SetRoomName sets the "room_name" field.
func (crc *ChatRoomCreate) SetRoomName(s string) *ChatRoomCreate {
	crc.mutation.SetRoomName(s)
	return crc
}

// SetCreatedAt sets the "created_at" field.
func (crc *ChatRoomCreate) SetCreatedAt(t time.Time) *ChatRoomCreate {
	crc.mutation.SetCreatedAt(t)
	return crc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (crc *ChatRoomCreate) SetNillableCreatedAt(t *time.Time) *ChatRoomCreate {
	if t != nil {
		crc.SetCreatedAt(*t)
	}
	return crc
}

// SetUpdatedAt sets the "updated_at" field.
func (crc *ChatRoomCreate) SetUpdatedAt(t time.Time) *ChatRoomCreate {
	crc.mutation.SetUpdatedAt(t)
	return crc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (crc *ChatRoomCreate) SetNillableUpdatedAt(t *time.Time) *ChatRoomCreate {
	if t != nil {
		crc.SetUpdatedAt(*t)
	}
	return crc
}

// SetDeletedAt sets the "deleted_at" field.
func (crc *ChatRoomCreate) SetDeletedAt(t time.Time) *ChatRoomCreate {
	crc.mutation.SetDeletedAt(t)
	return crc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (crc *ChatRoomCreate) SetNillableDeletedAt(t *time.Time) *ChatRoomCreate {
	if t != nil {
		crc.SetDeletedAt(*t)
	}
	return crc
}

// SetPostID sets the "post" edge to the Post entity by ID.
func (crc *ChatRoomCreate) SetPostID(id int) *ChatRoomCreate {
	crc.mutation.SetPostID(id)
	return crc
}

// SetNillablePostID sets the "post" edge to the Post entity by ID if the given value is not nil.
func (crc *ChatRoomCreate) SetNillablePostID(id *int) *ChatRoomCreate {
	if id != nil {
		crc = crc.SetPostID(*id)
	}
	return crc
}

// SetPost sets the "post" edge to the Post entity.
func (crc *ChatRoomCreate) SetPost(p *Post) *ChatRoomCreate {
	return crc.SetPostID(p.ID)
}

// AddChatIDs adds the "chats" edge to the Chat entity by IDs.
func (crc *ChatRoomCreate) AddChatIDs(ids ...int) *ChatRoomCreate {
	crc.mutation.AddChatIDs(ids...)
	return crc
}

// AddChats adds the "chats" edges to the Chat entity.
func (crc *ChatRoomCreate) AddChats(c ...*Chat) *ChatRoomCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return crc.AddChatIDs(ids...)
}

// AddProfileIDs adds the "profiles" edge to the Profile entity by IDs.
func (crc *ChatRoomCreate) AddProfileIDs(ids ...int) *ChatRoomCreate {
	crc.mutation.AddProfileIDs(ids...)
	return crc
}

// AddProfiles adds the "profiles" edges to the Profile entity.
func (crc *ChatRoomCreate) AddProfiles(p ...*Profile) *ChatRoomCreate {
	ids := make([]int, len(p))
	for i := range p {
		ids[i] = p[i].ID
	}
	return crc.AddProfileIDs(ids...)
}

// Mutation returns the ChatRoomMutation object of the builder.
func (crc *ChatRoomCreate) Mutation() *ChatRoomMutation {
	return crc.mutation
}

// Save creates the ChatRoom in the database.
func (crc *ChatRoomCreate) Save(ctx context.Context) (*ChatRoom, error) {
	crc.defaults()
	return withHooks[*ChatRoom, ChatRoomMutation](ctx, crc.sqlSave, crc.mutation, crc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (crc *ChatRoomCreate) SaveX(ctx context.Context) *ChatRoom {
	v, err := crc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (crc *ChatRoomCreate) Exec(ctx context.Context) error {
	_, err := crc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (crc *ChatRoomCreate) ExecX(ctx context.Context) {
	if err := crc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (crc *ChatRoomCreate) defaults() {
	if _, ok := crc.mutation.CreatedAt(); !ok {
		v := chatroom.DefaultCreatedAt()
		crc.mutation.SetCreatedAt(v)
	}
	if _, ok := crc.mutation.UpdatedAt(); !ok {
		v := chatroom.DefaultUpdatedAt()
		crc.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (crc *ChatRoomCreate) check() error {
	if _, ok := crc.mutation.RoomName(); !ok {
		return &ValidationError{Name: "room_name", err: errors.New(`ent: missing required field "ChatRoom.room_name"`)}
	}
	if v, ok := crc.mutation.RoomName(); ok {
		if err := chatroom.RoomNameValidator(v); err != nil {
			return &ValidationError{Name: "room_name", err: fmt.Errorf(`ent: validator failed for field "ChatRoom.room_name": %w`, err)}
		}
	}
	if _, ok := crc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "ChatRoom.created_at"`)}
	}
	if _, ok := crc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "ChatRoom.updated_at"`)}
	}
	if len(crc.mutation.ProfilesIDs()) == 0 {
		return &ValidationError{Name: "profiles", err: errors.New(`ent: missing required edge "ChatRoom.profiles"`)}
	}
	return nil
}

func (crc *ChatRoomCreate) sqlSave(ctx context.Context) (*ChatRoom, error) {
	if err := crc.check(); err != nil {
		return nil, err
	}
	_node, _spec := crc.createSpec()
	if err := sqlgraph.CreateNode(ctx, crc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	crc.mutation.id = &_node.ID
	crc.mutation.done = true
	return _node, nil
}

func (crc *ChatRoomCreate) createSpec() (*ChatRoom, *sqlgraph.CreateSpec) {
	var (
		_node = &ChatRoom{config: crc.config}
		_spec = sqlgraph.NewCreateSpec(chatroom.Table, sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt))
	)
	if value, ok := crc.mutation.RoomName(); ok {
		_spec.SetField(chatroom.FieldRoomName, field.TypeString, value)
		_node.RoomName = value
	}
	if value, ok := crc.mutation.CreatedAt(); ok {
		_spec.SetField(chatroom.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := crc.mutation.UpdatedAt(); ok {
		_spec.SetField(chatroom.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := crc.mutation.DeletedAt(); ok {
		_spec.SetField(chatroom.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if nodes := crc.mutation.PostIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chatroom.PostTable,
			Columns: []string{chatroom.PostColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(post.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.post_chat_rooms = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := crc.mutation.ChatsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chatroom.ChatsTable,
			Columns: []string{chatroom.ChatsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := crc.mutation.ProfilesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   chatroom.ProfilesTable,
			Columns: chatroom.ProfilesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// ChatRoomCreateBulk is the builder for creating many ChatRoom entities in bulk.
type ChatRoomCreateBulk struct {
	config
	builders []*ChatRoomCreate
}

// Save creates the ChatRoom entities in the database.
func (crcb *ChatRoomCreateBulk) Save(ctx context.Context) ([]*ChatRoom, error) {
	specs := make([]*sqlgraph.CreateSpec, len(crcb.builders))
	nodes := make([]*ChatRoom, len(crcb.builders))
	mutators := make([]Mutator, len(crcb.builders))
	for i := range crcb.builders {
		func(i int, root context.Context) {
			builder := crcb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ChatRoomMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, crcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, crcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, crcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (crcb *ChatRoomCreateBulk) SaveX(ctx context.Context) []*ChatRoom {
	v, err := crcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (crcb *ChatRoomCreateBulk) Exec(ctx context.Context) error {
	_, err := crcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (crcb *ChatRoomCreateBulk) ExecX(ctx context.Context) {
	if err := crcb.Exec(ctx); err != nil {
		panic(err)
	}
}
